import { QueryLatestValsetNonceResponse, QueryAllValsetResponse } from '@routerprotocol/chain-api/attestation/query_pb';
import BaseConsumer from './BaseGrpcConsumer';
/**
 * @category Chain Grpc API
 */
export declare class ChainGrpcAttestationApi extends BaseConsumer {
    fetchLatestValsetNonce(): Promise<QueryLatestValsetNonceResponse.AsObject>;
    fetchAllValsets(): Promise<QueryAllValsetResponse.AsObject>;
    fetchValsetByNonce(valsetNonce: number): Promise<{
        valset: import("@routerprotocol/chain-api/attestation/valset_pb").Valset.AsObject;
    }>;
    fetchLatestValset(): Promise<{
        valset: import("@routerprotocol/chain-api/attestation/valset_pb").Valset.AsObject;
    }>;
    fetchLastEventByValidator(chainType: number, chainId: string, valAddress: string): Promise<{
        eventNonce: number;
    }>;
    fetchAllOrchestrators(): Promise<{
        orchestrator_set: import("@routerprotocol/chain-api/attestation/tx_pb").MsgSetOrchestratorAddress.AsObject[];
    }>;
}
