import { QueryAllOutgoingBatchTxResponse, QueryGetOutgoingBatchTxResponse, QueryGetOutgoingBatchConfirmResponse, QueryAllOutgoingBatchConfirmResponse, QueryLastOutboundBatchNonceResponse } from '@routerprotocol/chain-api/outbound/query_pb';
import BaseConsumer from './BaseGrpcConsumer';
/**
 * @category Chain Grpc API
 */
export declare class ChainGrpcOutboundApi extends BaseConsumer {
    fetchAllOutgoingBatchTx(): Promise<QueryAllOutgoingBatchTxResponse.AsObject>;
    fetchOutgoingBatchTx(destinationChainType: number, destinationChainId: string, sourceAddress: string, batchNonce: number): Promise<QueryGetOutgoingBatchTxResponse.AsObject>;
    fetchOutgoingBatchTxConfirm(destinationChainType: number, destinationChainId: string, sourceAddress: string, batchNonce: number, orchestrator: string): Promise<QueryGetOutgoingBatchConfirmResponse.AsObject>;
    fetchAllOutgoingBatchTxConfirms(destinationChainType: number, destinationChainId: string, sourceAddress: string, batchNonce: number): Promise<QueryAllOutgoingBatchConfirmResponse.AsObject>;
    fetchLastOutboundBatchNonce(destinationChainType: number, destinationChainId: string, sourceAddress: string): Promise<QueryLastOutboundBatchNonceResponse.AsObject>;
}
