'use strict';

var query_pb_service = require('@routerprotocol/chain-api/cosmos/bank/v1beta1/query_pb_service');
var query_pb = require('@routerprotocol/chain-api/cosmos/bank/v1beta1/query_pb');
var grpcWeb = require('@improbable-eng/grpc-web');
var grpcWebNodeHttpTransport = require('@improbable-eng/grpc-web-node-http-transport');
var query_pb_service$1 = require('@routerprotocol/chain-api/attestation/query_pb_service');
var query_pb$1 = require('@routerprotocol/chain-api/attestation/query_pb');
var query_pb_service$2 = require('@routerprotocol/chain-api/inbound/query_pb_service');
var query_pb$2 = require('@routerprotocol/chain-api/inbound/query_pb');
var query_pb_service$3 = require('@routerprotocol/chain-api/outbound/query_pb_service');
var query_pb$3 = require('@routerprotocol/chain-api/outbound/query_pb');
var query_pb_service$4 = require('@routerprotocol/chain-api/multichain/query_pb_service');
var query_pb$4 = require('@routerprotocol/chain-api/multichain/query_pb');
var query_pb_service$5 = require('@routerprotocol/chain-api/cosmwasm/wasm/v1/query_pb_service');
var query_pb$5 = require('@routerprotocol/chain-api/cosmwasm/wasm/v1/query_pb');
var routerChainSdkTs = require('@routerprotocol/router-chain-sdk-ts');

function loadNetwork(name, node) {
  if (name == "local") {
    return {
      apiEndpoint: "https://localhost:1317",
      tmEndpoint: "http://localhost:26657",
      chainGrpcEndpoint: "tcp://localhost:9090",
      chainId: "router-1",
      chainTlsCert: "",
      exchangeTlsCert: "",
      feeDenom: "router",
      name: "local"
    };
  } else if (name == "local-docker") {
    return {
      apiEndpoint: "http://router-chain-container:1317",
      tmEndpoint: "http://router-chain-container:26657",
      chainGrpcEndpoint: "tcp://router-chain-container:9090",
      chainId: "router-1",
      chainTlsCert: "",
      exchangeTlsCert: "",
      feeDenom: "router",
      name: "local-docker"
    };
  } else if (name == "devnet-alpha") {
    return {
      apiEndpoint: "https://devnet-alpha.lcd.routerprotocol.com:443",
      tmEndpoint: "https://devnet-alpha.tm.routerprotocol.com:443",
      chainGrpcEndpoint: "https://devnet-alpha.grpcweb.routerprotocol.com",
      chainId: "router-1",
      chainTlsCert: "",
      exchangeTlsCert: "",
      feeDenom: "router",
      name: "devnet-alpha"
    };
  } else if (name == "devnet-alpha-nondocker") {
    return {
      apiEndpoint: "http://3.110.19.140:1317",
      tmEndpoint: "http://3.110.19.140:26657",
      chainGrpcEndpoint: "tcp://3.110.19.140:9090",
      chainId: "router-1",
      chainTlsCert: "",
      exchangeTlsCert: "",
      feeDenom: "router",
      name: "devnet-alpha-nondocker"
    };
  } else if (name == "devnet") {
    return {
      apiEndpoint: "http://43.205.211.15:1317",
      tmEndpoint: "http://43.205.211.15:26657",
      chainGrpcEndpoint: "tcp://43.205.211.15:9090",
      chainId: "router-1",
      chainTlsCert: "",
      exchangeTlsCert: "",
      feeDenom: "router",
      name: "devnet"
    };
  }
  return {
    apiEndpoint: "",
    tmEndpoint: "",
    chainGrpcEndpoint: "",
    chainId: "",
    chainTlsCert: "",
    exchangeTlsCert: "",
    feeDenom: "",
    name: ""
  };
}

function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return exports;
  };
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    defineProperty = Object.defineProperty || function (obj, key, desc) {
      obj[key] = desc.value;
    },
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return defineProperty(generator, "_invoke", {
      value: makeInvokeMethod(innerFn, self, context)
    }), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    defineProperty(this, "_invoke", {
      value: function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(innerFn, self, context) {
    var state = "suspendedStart";
    return function (method, arg) {
      if ("executing" === state) throw new Error("Generator is already running");
      if ("completed" === state) {
        if ("throw" === method) throw arg;
        return doneResult();
      }
      for (context.method = method, context.arg = arg;;) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }
        if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
          if ("suspendedStart" === state) throw state = "completed", context.arg;
          context.dispatchException(context.arg);
        } else "return" === context.method && context.abrupt("return", context.arg);
        state = "executing";
        var record = tryCatch(innerFn, self, context);
        if ("normal" === record.type) {
          if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
          return {
            value: record.arg,
            done: context.done
          };
        }
        "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
      }
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var methodName = context.method,
      method = delegate.iterator[methodName];
    if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), defineProperty(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (val) {
    var object = Object(val),
      keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

{
  grpcWeb.grpc.setDefaultTransport(grpcWebNodeHttpTransport.NodeHttpTransport());
}
/**
 * @hidden
 */
var BaseGrpcConsumer = /*#__PURE__*/function () {
  function BaseGrpcConsumer(endpoint) {
    this.endpoint = endpoint;
  }
  var _proto = BaseGrpcConsumer.prototype;
  _proto.request = function request(_request, service) {
    var _this = this;
    return new Promise(function (resolve, reject) {
      grpcWeb.grpc.unary(service, {
        request: _request,
        host: _this.endpoint,
        onEnd: function onEnd(res) {
          var statusMessage = res.statusMessage,
            status = res.status,
            message = res.message;
          if (status === grpcWeb.grpc.Code.OK && message) {
            resolve(message);
          }
          reject(new Error(statusMessage));
        }
      });
    });
  };
  return BaseGrpcConsumer;
}();

var getPageObject = function getPageObject(page) {
  if (page == undefined) return undefined;
  return {
    nextKey: page.getNextKey(),
    total: page.getTotal()
  };
};
var getCoinObject = function getCoinObject(coin) {
  return {
    denom: coin.getDenom(),
    amount: coin.getAmount()
  };
};

/**
 * @category Chain Grpc Transformer
 */
var BankTransformer = /*#__PURE__*/function () {
  function BankTransformer() {}
  BankTransformer.balanceResponseToBalance = function balanceResponseToBalance(response) {
    var balance = response.getBalance();
    if (balance == undefined) {
      return {
        balance: undefined
      };
    }
    return {
      balance: getCoinObject(balance)
    };
  };
  BankTransformer.balancesResponseToBalances = function balancesResponseToBalances(response) {
    var balances = response.getBalancesList();
    var pagination = response.getPagination();
    return {
      balancesList: balances.map(getCoinObject),
      pagination: getPageObject(pagination)
    };
  };
  return BankTransformer;
}();

/**
 * @category Chain Grpc Transformer
 */
var AttestationTransformer = /*#__PURE__*/function () {
  function AttestationTransformer() {}
  AttestationTransformer.latestValsetNonce = function latestValsetNonce(response) {
    return {
      valsetnonce: response.getValsetnonce()
    };
  };
  AttestationTransformer.allValset = function allValset(response) {
    var valsetList = response.getValsetList();
    var valsetObjectList = valsetList.map(AttestationTransformer.getValsetObject);
    var page = response.getPagination();
    return {
      valsetList: valsetObjectList,
      pagination: getPageObject(page)
    };
  };
  AttestationTransformer.valsetByNonce = function valsetByNonce(response) {
    var valset = response.getValset();
    if (valset == undefined) {
      return {
        valset: undefined
      };
    }
    return {
      valset: AttestationTransformer.getValsetObject(valset)
    };
  };
  AttestationTransformer.latestValset = function latestValset(response) {
    var valset = response.getValset();
    if (valset == undefined) {
      return {
        valset: undefined
      };
    }
    return {
      valset: AttestationTransformer.getValsetObject(valset)
    };
  };
  AttestationTransformer.lastEventByValidator = function lastEventByValidator(response) {
    return {
      eventNonce: response.getEventnonce()
    };
  };
  AttestationTransformer.listOrchestrators = function listOrchestrators(response) {
    var orchestratorSet = response.getOrchestratorSetList();
    return {
      orchestrator_set: orchestratorSet.map(AttestationTransformer.getOrchestratorObject)
    };
  };
  AttestationTransformer.getOrchestratorObject = function getOrchestratorObject(orchestrator) {
    return {
      validator: orchestrator.getValidator(),
      orchestrator: orchestrator.getOrchestrator(),
      ethaddress: orchestrator.getOrchestrator()
    };
  };
  AttestationTransformer.getValsetObject = function getValsetObject(valset) {
    var members = valset.getMembersList();
    var memberObjects = members.map(AttestationTransformer.getMemberObject);
    return {
      nonce: valset.getNonce(),
      membersList: memberObjects,
      height: valset.getHeight()
    };
  };
  AttestationTransformer.getMemberObject = function getMemberObject(member) {
    return {
      power: member.getPower(),
      ethereumaddress: member.getEthereumaddress()
    };
  };
  return AttestationTransformer;
}();

/**
 * @category Chain Grpc Transformer
 */
var MultiChainTransformer = /*#__PURE__*/function () {
  function MultiChainTransformer() {}
  MultiChainTransformer.chainConfig = function chainConfig(response) {
    var chainConfig = response.getChainconfig();
    if (chainConfig == undefined) {
      return {
        chainconfig: undefined
      };
    }
    return {
      chainconfig: MultiChainTransformer.getChainConfigObject(chainConfig)
    };
  };
  MultiChainTransformer.allChainConfig = function allChainConfig(response) {
    var chainConfigList = response.getChainconfigList();
    var page = response.getPagination();
    return {
      chainconfigList: chainConfigList.map(MultiChainTransformer.getChainConfigObject),
      pagination: getPageObject(page)
    };
  };
  MultiChainTransformer.getChainConfigObject = function getChainConfigObject(chainConfig) {
    return {
      chainid: chainConfig.getChainid(),
      chainname: chainConfig.getChainname(),
      symbol: chainConfig.getSymbol(),
      chaintype: chainConfig.getChaintype(),
      confirmationsrequired: chainConfig.getConfirmationsrequired(),
      gatewaycontractaddress: chainConfig.getGatewaycontractaddress(),
      gatewaycontractheight: chainConfig.getGatewaycontractheight(),
      routercontractaddress: chainConfig.getRoutercontractaddress(),
      lastobservedeventnonce: chainConfig.getLastobservedeventnonce(),
      lastobservedeventblockheight: chainConfig.getLastobservedeventblockheight(),
      lastobservedvalsetnonce: chainConfig.getLastobservedvalsetnonce(),
      chainEnabled: chainConfig.getChainEnabled(),
      creator: chainConfig.getCreator()
    };
  };
  return MultiChainTransformer;
}();

/**
 * @category Chain Grpc Transformer
 */
var InboundTransformer = /*#__PURE__*/function () {
  function InboundTransformer() {}
  InboundTransformer.incomingTx = function incomingTx(response) {
    var incomingTx = response.getIncomingtx();
    if (incomingTx == undefined) {
      return {
        incomingtx: undefined
      };
    }
    return {
      incomingtx: InboundTransformer.imcomingTxObject(incomingTx)
    };
  };
  InboundTransformer.imcomingTxObject = function imcomingTxObject(incomingTx) {
    return {
      chaintype: incomingTx.getChaintype(),
      chainid: incomingTx.getChainid(),
      eventnonce: incomingTx.getEventnonce(),
      blockheight: incomingTx.getBlockheight(),
      sourcetxhash: incomingTx.getSourcetxhash(),
      sourcesender: incomingTx.getSourcesender(),
      routerbridgecontract: incomingTx.getRouterbridgecontract(),
      payload: incomingTx.getPayload(),
      status: incomingTx.getStatus()
    };
  };
  return InboundTransformer;
}();

/**
 * @category Chain Grpc Transformer
 */
var OutboundTransformer = /*#__PURE__*/function () {
  function OutboundTransformer() {}
  OutboundTransformer.allOutgoingBatchTx = function allOutgoingBatchTx(response) {
    var outgoingTxs = response.getOutgoingbatchtxList();
    var page = response.getPagination();
    return {
      outgoingbatchtxList: outgoingTxs.map(OutboundTransformer.getOutgoingBatchTxObject),
      pagination: getPageObject(page)
    };
  };
  OutboundTransformer.outgoingBatchTx = function outgoingBatchTx(response) {
    var outgoingTx = response.getOutgoingbatchtx();
    if (outgoingTx == undefined) {
      return {
        outgoingbatchtx: undefined
      };
    }
    return {
      outgoingbatchtx: OutboundTransformer.getOutgoingBatchTxObject(outgoingTx)
    };
  };
  OutboundTransformer.outgoingBatchTxConfirm = function outgoingBatchTxConfirm(response) {
    var outgoingBatchTxConfirm = response.getOutgoingbatchconfirm();
    if (outgoingBatchTxConfirm == undefined) {
      return {
        outgoingbatchconfirm: undefined
      };
    }
    return {
      outgoingbatchconfirm: OutboundTransformer.getOutgoingBatchTxConfirmObject(outgoingBatchTxConfirm)
    };
  };
  OutboundTransformer.allOutgoingBatchTxConfirms = function allOutgoingBatchTxConfirms(response) {
    var outgoingBatchConfirmList = response.getOutgoingbatchconfirmList();
    var page = response.getPagination();
    return {
      outgoingbatchconfirmList: outgoingBatchConfirmList.map(OutboundTransformer.getOutgoingBatchTxConfirmObject),
      pagination: getPageObject(page)
    };
  };
  OutboundTransformer.lastOutboundBatchNonce = function lastOutboundBatchNonce(response) {
    return {
      outboundbatchnonce: response.getOutboundbatchnonce()
    };
  };
  OutboundTransformer.getOutgoingBatchTxConfirmObject = function getOutgoingBatchTxConfirmObject(outgoingBatchTxConfirm) {
    return {
      destinationchaintype: outgoingBatchTxConfirm.getDestinationchaintype(),
      destinationchainid: outgoingBatchTxConfirm.getDestinationchainid(),
      outgoingbatchsender: outgoingBatchTxConfirm.getOutgoingbatchsender(),
      outgoingbatchnonce: outgoingBatchTxConfirm.getOutgoingbatchnonce(),
      ethsigner: outgoingBatchTxConfirm.getEthsigner(),
      signature: outgoingBatchTxConfirm.getSignature(),
      orchestrator: outgoingBatchTxConfirm.getOrchestrator()
    };
  };
  OutboundTransformer.getOutgoingBatchTxObject = function getOutgoingBatchTxObject(outgoingBatchTx) {
    var relayerFee = outgoingBatchTx.getRelayerfee();
    var outgoingTxFee = outgoingBatchTx.getOutgoingtxfee();
    return {
      nonce: outgoingBatchTx.getNonce(),
      destinationchaintype: outgoingBatchTx.getDestinationchaintype(),
      destinationchainid: outgoingBatchTx.getDestinationchainid(),
      contractcallsList: outgoingBatchTx.getContractcallsList().map(OutboundTransformer.getContractCallObject),
      relayerfee: relayerFee ? getCoinObject(relayerFee) : undefined,
      outgoingtxfee: outgoingTxFee ? getCoinObject(outgoingTxFee) : undefined,
      expirytimestamp: outgoingBatchTx.getExpirytimestamp(),
      isatomic: outgoingBatchTx.getIsatomic(),
      sourceaddress: outgoingBatchTx.getSourceaddress(),
      status: outgoingBatchTx.getStatus()
    };
  };
  OutboundTransformer.getContractCallObject = function getContractCallObject(contractCall) {
    return {
      destinationcontractaddress: contractCall.getDestinationcontractaddress(),
      payload: contractCall.getPayload()
    };
  };
  return OutboundTransformer;
}();

/**
 * @category Chain Grpc Transformer
 */
var WasmTransformer = /*#__PURE__*/function () {
  function WasmTransformer() {}
  WasmTransformer.smartContractState = function smartContractState(response) {
    return {
      data: response.getData()
    };
  };
  WasmTransformer.rawContractState = function rawContractState(response) {
    return {
      data: response.getData()
    };
  };
  return WasmTransformer;
}();

/**
 * @category Chain Grpc API
 */
var ChainGrpcBankApi = /*#__PURE__*/function (_BaseConsumer) {
  _inheritsLoose(ChainGrpcBankApi, _BaseConsumer);
  function ChainGrpcBankApi() {
    return _BaseConsumer.apply(this, arguments) || this;
  }
  var _proto = ChainGrpcBankApi.prototype;
  _proto.fetchBalance = /*#__PURE__*/function () {
    var _fetchBalance = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
      var accountAddress, denom, request, response;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            accountAddress = _ref.accountAddress, denom = _ref.denom;
            request = new query_pb.QueryBalanceRequest();
            request.setAddress(accountAddress);
            request.setDenom(denom);
            _context.prev = 4;
            _context.next = 7;
            return this.request(request, query_pb_service.Query.Balance);
          case 7:
            response = _context.sent;
            return _context.abrupt("return", BankTransformer.balanceResponseToBalance(response));
          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](4);
            throw new Error(_context.t0.message);
          case 14:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[4, 11]]);
    }));
    function fetchBalance(_x) {
      return _fetchBalance.apply(this, arguments);
    }
    return fetchBalance;
  }();
  _proto.fetchBalances = /*#__PURE__*/function () {
    var _fetchBalances = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(address) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            request = new query_pb.QueryAllBalancesRequest();
            request.setAddress(address);
            _context2.prev = 2;
            _context2.next = 5;
            return this.request(request, query_pb_service.Query.AllBalances);
          case 5:
            response = _context2.sent;
            return _context2.abrupt("return", BankTransformer.balancesResponseToBalances(response));
          case 9:
            _context2.prev = 9;
            _context2.t0 = _context2["catch"](2);
            throw new Error(_context2.t0.message);
          case 12:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this, [[2, 9]]);
    }));
    function fetchBalances(_x2) {
      return _fetchBalances.apply(this, arguments);
    }
    return fetchBalances;
  }();
  return ChainGrpcBankApi;
}(BaseGrpcConsumer);

/**
 * @category Chain Grpc API
 */
var ChainGrpcAttestationApi = /*#__PURE__*/function (_BaseConsumer) {
  _inheritsLoose(ChainGrpcAttestationApi, _BaseConsumer);
  function ChainGrpcAttestationApi() {
    return _BaseConsumer.apply(this, arguments) || this;
  }
  var _proto = ChainGrpcAttestationApi.prototype;
  _proto.fetchLatestValsetNonce = /*#__PURE__*/function () {
    var _fetchLatestValsetNonce = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            request = new query_pb$1.QueryLatestValsetNonceRequest();
            _context.prev = 1;
            _context.next = 4;
            return this.request(request, query_pb_service$1.Query.LatestValsetNonce);
          case 4:
            response = _context.sent;
            return _context.abrupt("return", AttestationTransformer.latestValsetNonce(response));
          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](1);
            throw new Error(_context.t0.message);
          case 11:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[1, 8]]);
    }));
    function fetchLatestValsetNonce() {
      return _fetchLatestValsetNonce.apply(this, arguments);
    }
    return fetchLatestValsetNonce;
  }();
  _proto.fetchAllValsets = /*#__PURE__*/function () {
    var _fetchAllValsets = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            request = new query_pb$1.QueryAllValsetRequest();
            _context2.prev = 1;
            _context2.next = 4;
            return this.request(request, query_pb_service$1.Query.ValsetAll);
          case 4:
            response = _context2.sent;
            return _context2.abrupt("return", AttestationTransformer.allValset(response));
          case 8:
            _context2.prev = 8;
            _context2.t0 = _context2["catch"](1);
            throw new Error(_context2.t0.message);
          case 11:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this, [[1, 8]]);
    }));
    function fetchAllValsets() {
      return _fetchAllValsets.apply(this, arguments);
    }
    return fetchAllValsets;
  }();
  _proto.fetchValsetByNonce = /*#__PURE__*/function () {
    var _fetchValsetByNonce = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(valsetNonce) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            request = new query_pb$1.QueryGetValsetRequest();
            request.setNonce(valsetNonce);
            _context3.prev = 2;
            _context3.next = 5;
            return this.request(request, query_pb_service$1.Query.Valset);
          case 5:
            response = _context3.sent;
            return _context3.abrupt("return", AttestationTransformer.valsetByNonce(response));
          case 9:
            _context3.prev = 9;
            _context3.t0 = _context3["catch"](2);
            throw new Error(_context3.t0.message);
          case 12:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this, [[2, 9]]);
    }));
    function fetchValsetByNonce(_x) {
      return _fetchValsetByNonce.apply(this, arguments);
    }
    return fetchValsetByNonce;
  }();
  _proto.fetchLatestValset = /*#__PURE__*/function () {
    var _fetchLatestValset = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4() {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            request = new query_pb$1.QueryLatestValsetRequest();
            _context4.prev = 1;
            _context4.next = 4;
            return this.request(request, query_pb_service$1.Query.LatestValset);
          case 4:
            response = _context4.sent;
            return _context4.abrupt("return", AttestationTransformer.latestValset(response));
          case 8:
            _context4.prev = 8;
            _context4.t0 = _context4["catch"](1);
            throw new Error(_context4.t0.message);
          case 11:
          case "end":
            return _context4.stop();
        }
      }, _callee4, this, [[1, 8]]);
    }));
    function fetchLatestValset() {
      return _fetchLatestValset.apply(this, arguments);
    }
    return fetchLatestValset;
  }();
  _proto.fetchLastEventByValidator = /*#__PURE__*/function () {
    var _fetchLastEventByValidator = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(chainType, chainId, valAddress) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            request = new query_pb$1.QueryLastEventNonceRequest();
            request.setChainType(chainType);
            request.setChainId(chainId);
            request.setValidatorAddress(valAddress);
            _context5.prev = 4;
            _context5.next = 7;
            return this.request(request, query_pb_service$1.Query.LastEventNonce);
          case 7:
            response = _context5.sent;
            return _context5.abrupt("return", AttestationTransformer.lastEventByValidator(response));
          case 11:
            _context5.prev = 11;
            _context5.t0 = _context5["catch"](4);
            throw new Error(_context5.t0.message);
          case 14:
          case "end":
            return _context5.stop();
        }
      }, _callee5, this, [[4, 11]]);
    }));
    function fetchLastEventByValidator(_x2, _x3, _x4) {
      return _fetchLastEventByValidator.apply(this, arguments);
    }
    return fetchLastEventByValidator;
  }();
  _proto.fetchAllOrchestrators = /*#__PURE__*/function () {
    var _fetchAllOrchestrators = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6() {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            request = new query_pb$1.QueryListOrchestratorsRequest();
            _context6.prev = 1;
            _context6.next = 4;
            return this.request(request, query_pb_service$1.Query.ListOrchestrators);
          case 4:
            response = _context6.sent;
            return _context6.abrupt("return", AttestationTransformer.listOrchestrators(response));
          case 8:
            _context6.prev = 8;
            _context6.t0 = _context6["catch"](1);
            throw new Error(_context6.t0.message);
          case 11:
          case "end":
            return _context6.stop();
        }
      }, _callee6, this, [[1, 8]]);
    }));
    function fetchAllOrchestrators() {
      return _fetchAllOrchestrators.apply(this, arguments);
    }
    return fetchAllOrchestrators;
  }();
  return ChainGrpcAttestationApi;
}(BaseGrpcConsumer);

/**
 * @category Chain Grpc API
 */
var ChainGrpcInboundApi = /*#__PURE__*/function (_BaseConsumer) {
  _inheritsLoose(ChainGrpcInboundApi, _BaseConsumer);
  function ChainGrpcInboundApi() {
    return _BaseConsumer.apply(this, arguments) || this;
  }
  var _proto = ChainGrpcInboundApi.prototype;
  _proto.fetchIncomingTx = /*#__PURE__*/function () {
    var _fetchIncomingTx = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(chainType, chainId, eventNonce) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            request = new query_pb$2.QueryGetIncomingTxRequest();
            request.setChainType(chainType);
            request.setChainId(chainId);
            request.setEventNonce(eventNonce);
            _context.prev = 4;
            _context.next = 7;
            return this.request(request, query_pb_service$2.Query.IncomingTx);
          case 7:
            response = _context.sent;
            return _context.abrupt("return", InboundTransformer.incomingTx(response));
          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](4);
            throw new Error(_context.t0.message);
          case 14:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[4, 11]]);
    }));
    function fetchIncomingTx(_x, _x2, _x3) {
      return _fetchIncomingTx.apply(this, arguments);
    }
    return fetchIncomingTx;
  }();
  return ChainGrpcInboundApi;
}(BaseGrpcConsumer);

/**
 * @category Chain Grpc API
 */
var ChainGrpcOutboundApi = /*#__PURE__*/function (_BaseConsumer) {
  _inheritsLoose(ChainGrpcOutboundApi, _BaseConsumer);
  function ChainGrpcOutboundApi() {
    return _BaseConsumer.apply(this, arguments) || this;
  }
  var _proto = ChainGrpcOutboundApi.prototype;
  _proto.fetchAllOutgoingBatchTx = /*#__PURE__*/function () {
    var _fetchAllOutgoingBatchTx = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            request = new query_pb$3.QueryAllOutgoingBatchTxRequest();
            _context.prev = 1;
            _context.next = 4;
            return this.request(request, query_pb_service$3.Query.OutgoingBatchTxAll);
          case 4:
            response = _context.sent;
            return _context.abrupt("return", OutboundTransformer.allOutgoingBatchTx(response));
          case 8:
            _context.prev = 8;
            _context.t0 = _context["catch"](1);
            throw new Error(_context.t0.message);
          case 11:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[1, 8]]);
    }));
    function fetchAllOutgoingBatchTx() {
      return _fetchAllOutgoingBatchTx.apply(this, arguments);
    }
    return fetchAllOutgoingBatchTx;
  }();
  _proto.fetchOutgoingBatchTx = /*#__PURE__*/function () {
    var _fetchOutgoingBatchTx = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(destinationChainType, destinationChainId, sourceAddress, batchNonce) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            request = new query_pb$3.QueryGetOutgoingBatchTxRequest();
            request.setDestinationChainType(destinationChainType);
            request.setDestinationChainId(destinationChainId);
            request.setSourceAddress(sourceAddress);
            request.setNonce(batchNonce);
            _context2.prev = 5;
            _context2.next = 8;
            return this.request(request, query_pb_service$3.Query.OutgoingBatchTx);
          case 8:
            response = _context2.sent;
            return _context2.abrupt("return", OutboundTransformer.outgoingBatchTx(response));
          case 12:
            _context2.prev = 12;
            _context2.t0 = _context2["catch"](5);
            throw new Error(_context2.t0.message);
          case 15:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this, [[5, 12]]);
    }));
    function fetchOutgoingBatchTx(_x, _x2, _x3, _x4) {
      return _fetchOutgoingBatchTx.apply(this, arguments);
    }
    return fetchOutgoingBatchTx;
  }();
  _proto.fetchOutgoingBatchTxConfirm = /*#__PURE__*/function () {
    var _fetchOutgoingBatchTxConfirm = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(destinationChainType, destinationChainId, sourceAddress, batchNonce, orchestrator) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            request = new query_pb$3.QueryGetOutgoingBatchConfirmRequest();
            request.setDestinationChainType(destinationChainType);
            request.setDestinationChainId(destinationChainId);
            request.setSourceAddress(sourceAddress);
            request.setNonce(batchNonce);
            request.setOrchestrator(orchestrator);
            _context3.prev = 6;
            _context3.next = 9;
            return this.request(request, query_pb_service$3.Query.OutgoingBatchConfirm);
          case 9:
            response = _context3.sent;
            return _context3.abrupt("return", OutboundTransformer.outgoingBatchTxConfirm(response));
          case 13:
            _context3.prev = 13;
            _context3.t0 = _context3["catch"](6);
            throw new Error(_context3.t0.message);
          case 16:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this, [[6, 13]]);
    }));
    function fetchOutgoingBatchTxConfirm(_x5, _x6, _x7, _x8, _x9) {
      return _fetchOutgoingBatchTxConfirm.apply(this, arguments);
    }
    return fetchOutgoingBatchTxConfirm;
  }();
  _proto.fetchAllOutgoingBatchTxConfirms = /*#__PURE__*/function () {
    var _fetchAllOutgoingBatchTxConfirms = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(destinationChainType, destinationChainId, sourceAddress, batchNonce) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            request = new query_pb$3.QueryAllOutgoingBatchConfirmRequest();
            request.setDestinationChainType(destinationChainType);
            request.setDestinationChainId(destinationChainId);
            request.setSourceAddress(sourceAddress);
            request.setNonce(batchNonce);
            _context4.prev = 5;
            _context4.next = 8;
            return this.request(request, query_pb_service$3.Query.OutgoingBatchConfirmAll);
          case 8:
            response = _context4.sent;
            return _context4.abrupt("return", OutboundTransformer.allOutgoingBatchTxConfirms(response));
          case 12:
            _context4.prev = 12;
            _context4.t0 = _context4["catch"](5);
            throw new Error(_context4.t0.message);
          case 15:
          case "end":
            return _context4.stop();
        }
      }, _callee4, this, [[5, 12]]);
    }));
    function fetchAllOutgoingBatchTxConfirms(_x10, _x11, _x12, _x13) {
      return _fetchAllOutgoingBatchTxConfirms.apply(this, arguments);
    }
    return fetchAllOutgoingBatchTxConfirms;
  }();
  _proto.fetchLastOutboundBatchNonce = /*#__PURE__*/function () {
    var _fetchLastOutboundBatchNonce = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(destinationChainType, destinationChainId, sourceAddress) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            request = new query_pb$3.QueryLastOutboundBatchNonceRequest();
            request.setDestinationChainType(destinationChainType);
            request.setDestinationChainId(destinationChainId);
            request.setSourceAddress(sourceAddress);
            _context5.prev = 4;
            _context5.next = 7;
            return this.request(request, query_pb_service$3.Query.LastOutboundBatchNonce);
          case 7:
            response = _context5.sent;
            return _context5.abrupt("return", OutboundTransformer.lastOutboundBatchNonce(response));
          case 11:
            _context5.prev = 11;
            _context5.t0 = _context5["catch"](4);
            throw new Error(_context5.t0.message);
          case 14:
          case "end":
            return _context5.stop();
        }
      }, _callee5, this, [[4, 11]]);
    }));
    function fetchLastOutboundBatchNonce(_x14, _x15, _x16) {
      return _fetchLastOutboundBatchNonce.apply(this, arguments);
    }
    return fetchLastOutboundBatchNonce;
  }();
  return ChainGrpcOutboundApi;
}(BaseGrpcConsumer);

var ChainGrpcMultiChainApi = /*#__PURE__*/function (_BaseConsumer) {
  _inheritsLoose(ChainGrpcMultiChainApi, _BaseConsumer);
  function ChainGrpcMultiChainApi() {
    return _BaseConsumer.apply(this, arguments) || this;
  }
  var _proto = ChainGrpcMultiChainApi.prototype;
  _proto.fetchChainConfig = /*#__PURE__*/function () {
    var _fetchChainConfig = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(chainType, chainId) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            request = new query_pb$4.QueryGetChainConfigRequest();
            request.setChainType(chainType);
            request.setChainId(chainId);
            _context.prev = 3;
            _context.next = 6;
            return this.request(request, query_pb_service$4.Query.ChainConfig);
          case 6:
            response = _context.sent;
            console.log("api call success");
            return _context.abrupt("return", MultiChainTransformer.chainConfig(response));
          case 11:
            _context.prev = 11;
            _context.t0 = _context["catch"](3);
            throw new Error(_context.t0.message);
          case 14:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[3, 11]]);
    }));
    function fetchChainConfig(_x, _x2) {
      return _fetchChainConfig.apply(this, arguments);
    }
    return fetchChainConfig;
  }();
  _proto.fetchAllChainConfig = /*#__PURE__*/function () {
    var _fetchAllChainConfig = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            request = new query_pb$4.QueryAllChainConfigRequest();
            _context2.prev = 1;
            _context2.next = 4;
            return this.request(request, query_pb_service$4.Query.ChainConfigAll);
          case 4:
            response = _context2.sent;
            return _context2.abrupt("return", MultiChainTransformer.allChainConfig(response));
          case 8:
            _context2.prev = 8;
            _context2.t0 = _context2["catch"](1);
            throw new Error(_context2.t0.message);
          case 11:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this, [[1, 8]]);
    }));
    function fetchAllChainConfig() {
      return _fetchAllChainConfig.apply(this, arguments);
    }
    return fetchAllChainConfig;
  }();
  return ChainGrpcMultiChainApi;
}(BaseGrpcConsumer);

/**
 * @category Chain Grpc API
 */
var ChainGrpcWasmApi = /*#__PURE__*/function (_BaseConsumer) {
  _inheritsLoose(ChainGrpcWasmApi, _BaseConsumer);
  function ChainGrpcWasmApi() {
    return _BaseConsumer.apply(this, arguments) || this;
  }
  var _proto = ChainGrpcWasmApi.prototype;
  _proto.smartContractState = /*#__PURE__*/function () {
    var _smartContractState = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(contractAddress, queryData) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            request = new query_pb$5.QuerySmartContractStateRequest();
            request.setAddress(contractAddress);
            request.setQueryData(queryData);
            _context.prev = 3;
            _context.next = 6;
            return this.request(request, query_pb_service$5.Query.SmartContractState);
          case 6:
            response = _context.sent;
            return _context.abrupt("return", WasmTransformer.smartContractState(response));
          case 10:
            _context.prev = 10;
            _context.t0 = _context["catch"](3);
            throw new Error(_context.t0.message);
          case 13:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[3, 10]]);
    }));
    function smartContractState(_x, _x2) {
      return _smartContractState.apply(this, arguments);
    }
    return smartContractState;
  }();
  _proto.rawContractState = /*#__PURE__*/function () {
    var _rawContractState = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(contractAddress, queryData) {
      var request, response;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            request = new query_pb$5.QueryRawContractStateRequest();
            request.setAddress(contractAddress);
            request.setQueryData(queryData);
            _context2.prev = 3;
            _context2.next = 6;
            return this.request(request, query_pb_service$5.Query.RawContractState);
          case 6:
            response = _context2.sent;
            return _context2.abrupt("return", WasmTransformer.rawContractState(response));
          case 10:
            _context2.prev = 10;
            _context2.t0 = _context2["catch"](3);
            throw new Error(_context2.t0.message);
          case 13:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this, [[3, 10]]);
    }));
    function rawContractState(_x3, _x4) {
      return _rawContractState.apply(this, arguments);
    }
    return rawContractState;
  }();
  return ChainGrpcWasmApi;
}(BaseGrpcConsumer);

var ChainGrpcClient = function ChainGrpcClient(endpoint) {
  this.bank = new ChainGrpcBankApi(endpoint);
  this.attestation = new ChainGrpcAttestationApi(endpoint);
  this.inbound = new ChainGrpcInboundApi(endpoint);
  this.outbound = new ChainGrpcOutboundApi(endpoint);
  this.multichain = new ChainGrpcMultiChainApi(endpoint);
  this.wasm = new ChainGrpcWasmApi(endpoint);
};

function initialiseChainClient(networkName) {
  var networkEndpoints = loadNetwork(networkName);
  var client = new ChainGrpcClient(networkEndpoints.chainGrpcEndpoint);
  return client;
}

Object.keys(routerChainSdkTs).forEach(function (k) {
    if (k !== 'default') Object.defineProperty(exports, k, {
        enumerable: true,
        get: function () {
            return routerChainSdkTs[k];
        }
    });
});
exports.initialiseChainClient = initialiseChainClient;
//# sourceMappingURL=sdk-ts.cjs.development.js.map
